
  select co_sys_meta_class_add('sys', 'example_association', 'sys', 'generic_association' , '', '')
  !SELECT

  UPDATE co_sys_meta_class
	SET
		default_form = '',
		force_sec_type='',
		reloid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association')
	WHERE class_name = 'example_association'
  !GO

DELETE FROM co_sys_meta_prop WHERE class_name='example_association' and area='sys'
!GO
  
INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'id','READONLY=1;HIDDEN=1','0','sys','','',
         '', '', '', 
	 '0','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'id' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'version','READONLY=1;HIDDEN=1','0','sys','','',
         '', '', '', 
	 '0','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'version' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'deleted','READONLY=1;HIDDEN=1','0','sys','','',
         '', '', '', 
	 '0','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'deleted' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'inherits_acl','HIDDEN=1;READONLY=1','0','sys','','',
         '', '', '', 
	 '50','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'inherits_acl' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'id_foreign1','READONLY=1','0','sys','meta_tree','id',
         '', '', '', 
	 '100','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'id_foreign1' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

INSERT INTO co_sys_meta_prop(area, class_name, prop_name, prop_params, prop_representant, 
     prop_foreign_area, prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path, f_body, state, attoid)
  VALUES('sys', 'example_association', 'id_foreign2','READONLY=1','0','sys','meta_tree','id',
         '', '', '', 
	 '150','CO_INTEGER', '', '', 'INSYNC', 
     (SELECT oid FROM pg_attribute WHERE attname = 'id_foreign2' AND attrelid = (SELECT oid FROM pg_class WHERE relname='co_sys_example_association'))
        )
!GO

DELETE FROM co_sys_meta_method WHERE id_meta_class=
(SELECT id from co_sys_meta_class WHERE 
class_name='example_association' and area='sys')
!GO
