#include "init_file_names.t"  
#include "defines.t"      

file generic_association_menu
{

/* this is default menu that we can see on association forms */
class menu
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='associations#multi@generic_association'";
  p name       {val		'associations#multi@generic_association';};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		generic_association;};
};

/* multi_create */
class js_code
{
	area sys;

	full_control root;
        full_control user;

	p code
	{
		val
		%%
var current_class = eval("new class_"+context.active_class+"('"+COServer.getAreaName()+"')");
COServer.beginJSCreation();
current_class.EXT_insertAssociations({
  par_id: -1,
  callback: "parent.showReturned(",
  prop_first_class: context.column_first_class,
  ids_first_class: context.ids_first_class.split("|"),
  prop_second_class: context.column_second_class,
  ids_second_class: context.ids_second_class.split("|")
});
COServer.endJSCreation();
		%%
		;
	};
};    

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_multi_create_associations'";

   p name {val generic_multi_create_associations;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val column_first_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val ids_first_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val column_second_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val ids_second_class;};
  p id_menu_action {recent menu_action;};
};  

class menu
{
	area sys;

	full_control root;
	full_control user;

	remove_old "name='multi_create_associations'";

	p name {val multi_create_associations;};
	p display_name {val 'Nowe asocjacje';};
	p class_name {val generic_association;};
	p id_parent { getByName menu {f 'associations#multi@generic_association';};};
	p id_menu_action {recent menu_action;};
	p id_permission {val __PERMISSION_CREATE ;};
	p menu_position {val 200; };
	p sec_type {val __METHOD_SEC_TYPE_CLASS;};
};

/* end of multi_test */
}; // end of file menu_generic_acl
