# Created automatically from ../../comodules/tools/Jeeves/examples/modules_sql.tpl
use Ast;
use JeevesUtil;

$tmp_file = "jeeves.tmp";

sub open_file;
if (! (defined ($ROOT) && $ROOT)) {
    die "ROOT not defined";
}

$file = "> -";
open (F, $file) || die $@;
$code = "";
$ROOT->visit();
 use co_modules_functions;
output("\n");
 $user = $ENV{"USER"};
output("\n");
# Line 5
foreach $item_list_i (@${item_list}) {
    $item_list_i->visit ();
output("\n");
 @co_type_map;
# Line 9
foreach $type_i (@${type}) {
    $type_i->visit ();
 @${c_type}[0]->visit ();  
 @${pointer}[0]->visit ();  
 @${is_array}[0]->visit ();  
 @${sql_type}[0]->visit ();    
 $co_type_map[0]{$name_type} = { "c_type" => $name_c_type, "pointer" => $name_pointer, "is_array" => $name_is_array, "sql_type"=>$name_sql_type};
output("    \n");
#Line 16
    Ast->bye();
}
output("\n");
output("\n");
# Line 20
foreach $class_i (@${class}) {
    $class_i->visit ();
# Line 21
foreach $area_i (@${area}) {
    $area_i->visit ();
output("\n");
# Line 23
open_file("co_create_${name_area}_${name_class}.sql", 0, 0, 0);
output("  \n");
output("/******************************************************************/\n");
output("/*                                                                */ \n");
output("/* CREATION OF co_${name_area}_${name_class};                     */\n");
output("/*                                                                */\n");
output("/******************************************************************/\n");
output("\n");
# Line 31
foreach $sequence_i (@${sequence}) {
    $sequence_i->visit ();
output("      drop sequence co_${name_area}_${name_class}_${name_sequence}\n");
output("      !NOERROR\n");
output("      create sequence co_${name_area}_${name_class}_${name_sequence} start 1\n");
output("      !GO\n");
output("      grant all on co_${name_area}_${name_class}_${name_sequence} to nobody\n");
output("      !GO\n");
#Line 38
    Ast->bye();
}
output("\n");
output("  drop table co_${name_area}_${name_class}\n");
output("  !NOERROR\n");
output("  create table co_${name_area}_${name_class}\n");
output("  (\n");
 $i=0;  
# Line 45
foreach $prop_i (@${prop}) {
    $prop_i->visit ();
 @${type}[0]->visit ();
 $sql_type = $co_type_map[0]{$name_type}->{"sql_type"};
output("      $name_prop  $sql_type default\n");
# Line 49
foreach $default_i (@${default}) {
    $default_i->visit ();
 if($name_default eq "SEQUENCE") {
# Line 51
foreach $sq_name_i (@${sq_name}) {
    $sq_name_i->visit ();
output("           nextval(\'co_${name_area}_${name_class}_${name_sq_name}\'::text)\n");
#Line 53
    Ast->bye();
}
 }else{
output("           $name_default\n");
 } 
#Line 57
    Ast->bye();
}
 if ($i != $#${prop}) {
output("        ,\n");
 }
 $i++;
#Line 62
    Ast->bye();
}
output("  )\n");
output("  !GO\n");
output("  grant all on co_${name_area}_${name_class} to nobody\n");
output("  !GO\n");
output("  \n");
# Line 68
foreach $index_i (@${index}) {
    $index_i->visit ();
output("    DROP INDEX co_${name_area}_${name_class}_${name_index}\n");
output("    !NOERROR\n");
output("    \n");
output("    CREATE \n");
# Line 73
foreach $unique_i (@${unique}) {
    $unique_i->visit ();
 if($name_unique == 1) {
output("      UNIQUE\n");
 } 
#Line 77
    Ast->bye();
}
output("    INDEX co_${name_area}_${name_class}_${name_index}\n");
output("    ON co_${name_area}_${name_class}\n");
output("    ( \n");
 $i=0;  
# Line 82
foreach $column_i (@${column}) {
    $column_i->visit ();
output("      $name_column\n");
 if ($i != $#${column}) {
output("        ,\n");
 }
 $i++;
#Line 88
    Ast->bye();
}
output("    )\n");
output("    !GO\n");
output("    \n");
#Line 92
    Ast->bye();
}
output("  \n");
# Line 94
open_file("co_init_${name_area}_${name_class}.sql", 0, 0, 0);
output("\n");
 @${inherits}[0]->visit ();
 @${container_class}[0]->visit ();
 @${container_column_name}[0]->visit ();
output("\n");
output("  \n");
output("  select co_${name_area}_meta_class_add(\'$name_class\', \'$name_inherits\' , \'$name_container_class\', \'$name_container_column_name\')\n");
output("  !SELECT\n");
output("\n");
# Line 104
foreach $default_form_i (@${default_form}) {
    $default_form_i->visit ();
output("    UPDATE co_${name_area}_meta_class SET default_form = \'$name_default_form\' WHERE class_name = \'$name_class\'\n");
output("    !GO\n");
#Line 107
    Ast->bye();
}
output("\n");
output("DELETE FROM co_${name_area}_meta_prop WHERE class_name=\'$name_class\'\n");
output("!GO\n");
# Line 111
foreach $prop_i (@${prop}) {
    $prop_i->visit ();
 @${type}[0]->visit ();
 @${params}[0]->visit ();
 @${representant}[0]->visit ();
 @${foreign}[0]->visit ();
 @${foreign_prop}[0]->visit ();
 @${position}[0]->visit ();
output("\n");
output("insert into co_${name_area}_meta_prop(class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_foreign_prop, prop_position, prop_type)\n");
output("  values(\'$name_class\', \'$name_prop\',\'$name_params\',\'$name_representant\',\'$name_foreign\',\'$name_foreign_prop\',\'$name_position\',\'$name_type\')\n");
output("!GO  \n");
output(" \n");
output("		    \n");
#Line 124
    Ast->bye();
}
output("\n");
output("DELETE FROM co_${name_area}_meta_method WHERE class_name=\'$name_class\'\n");
output("!GO\n");
output("\n");
# Line 129
foreach $method_i (@${method}) {
    $method_i->visit ();
# Line 130
foreach $id_permission_i (@${id_permission}) {
    $id_permission_i->visit ();
# Line 131
open_file("co_init_${name_area}_${name_class}.sql", 0, 0, 1);
output("insert into co_${name_area}_meta_method(class_name, method_name, id_permission)\n");
output("            values(\'$name_class\', \'$name_method\',\'$name_id_permission\')\n");
output("!GO\n");
#Line 135
    Ast->bye();
}
# Line 136
foreach $profiled_i (@${profiled}) {
    $profiled_i->visit ();
# Line 137
open_file("co_init_${name_area}_${name_class}.sql", 0, 0, 1);
output("update co_${name_area}_meta_method set profiled=1\n");
output("where class_name=\'$name_class\' and method_name=\'$name_method\'\n");
output("!GO\n");
 undef($profiled_i);
#Line 142
    Ast->bye();
}
 undef(@${profiled});
# Line 144
foreach $server_event_i (@${server_event}) {
    $server_event_i->visit ();
# Line 145
foreach $execute_jscript_i (@${execute_jscript}) {
    $execute_jscript_i->visit ();
 $name_execute_jscript =~ s/([\"|\'|\\])/\\\1/g;
# Line 147
open_file("co_init_${name_area}_${name_class}.sql", 0, 0, 1);
output("insert into co_${name_area}_js_code(code) values(\'${name_execute_jscript}\')\n");
output("!GO\n");
output("update co_${name_area}_meta_method\n");
output("set id_${name_server_event}_script=(select last_value from co_${name_area}_js_code_sqid)\n");
output("where class_name=\'$name_class\' and method_name=\'$name_method\'\n");
output("!GO\n");
#Line 154
    Ast->bye();
}
# Line 155
foreach $execute_i (@${execute}) {
    $execute_i->visit ();
 @${class_name}[0]->visit ();
 @${method_name}[0]->visit ();
# Line 158
open_file("co_initv_${name_area}_${name_class}.sql", 0, 0, 1);
output("update co_${name_area}_meta_method\n");
output("set id_${name_server_event}_method=\n");
output("(select id from co_${name_area}_meta_method\n");
output(" where class_name=\'${name_class_name}\' and method_name=\'${name_method_name}\')\n");
output("where class_name=\'${name_class}\' and method_name=\'${name_method}\'\n");
output("!GO\n");
#Line 165
    Ast->bye();
}
 undef($server_event_i);
#Line 167
    Ast->bye();
}
 undef(@${server_event});
#Line 169
    Ast->bye();
}
output("\n");
# Line 171
open_file("co_initv_${name_area}_${name_class}.sql", 0, 0, 1);
output("/* now we generate entries for vtable */\n");
output("select co_${name_area}_meta_vtable_generate(\'${name_class}\')\n");
output("!SELECT\n");
# Line 175
open_file("co_functions_${name_area}_${name_class}.sql", 0, 0, 0);
output("/******************************************************************/\n");
output("/*                                                                */ \n");
output("/* CREATION OF SQL FUNCTIONS FOR co_${name_area}_${name_class};                     */\n");
output("/*                                                                */\n");
output("/******************************************************************/\n");
output("\n");
# Line 182
foreach $function_sql_i (@${function_sql}) {
    $function_sql_i->visit ();
output("    DROP FUNCTION co_${name_area}_${name_class}_${name_function_sql}\n");
# Line 184
foreach $params_i (@${params}) {
    $params_i->visit ();
output("       $name_params\n");
#Line 186
    Ast->bye();
}
output("     !NOERROR\n");
output("     \n");
output("    CREATE FUNCTION  co_${name_area}_${name_class}_${name_function_sql}\n");
# Line 190
foreach $params_i (@${params}) {
    $params_i->visit ();
output("       $name_params\n");
#Line 192
    Ast->bye();
}
output("    RETURNS\n");
# Line 194
foreach $returns_i (@${returns}) {
    $returns_i->visit ();
output("      $name_returns\n");
#Line 196
    Ast->bye();
}
output("    AS \'\n");
# Line 198
foreach $S_i (@${S}) {
    $S_i->visit ();
 if($name_S =~ s/^\s*\@//) {
 my($temp) = eval($name_S);
 my(@temp) = split "\n", $temp;
 foreach $t (@temp) {
output("$t\n");
 }}else{
 my(@temp) = split "\n", $name_S;
 foreach $t (@temp) { $t =~ s/^(\s+)//;
 if($t =~ s/^\@//) {
 my($temp) = eval($t);
output("       \n");
 my(@temp) = split "\n", $temp;
 foreach $t (@temp) {
output("$t\n");
 }}else{
output("$t\n");
} } }
#Line 219
    Ast->bye();
}
output("    \' LANGUAGE \'plpgsql\'\n");
output("    !GO\n");
output("    \n");
#Line 223
    Ast->bye();
}
output("  \n");
# Line 225
foreach $prop_i (@${prop}) {
    $prop_i->visit ();
 @${type}[0]->visit ();
 $sql_type = $co_type_map[0]{$name_type}->{"sql_type"};
output("\n");
output("     DROP FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type})\n");
output("     !NOERROR\n");
output("\n");
output("     CREATE FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type}) RETURNS co_${name_area}_${name_class} AS\n");
output("     \'\n");
output("        SELECT * FROM co_${name_area}_${name_class} WHERE co_${name_area}_${name_class}.${name_prop} = \$1\n");
output("     \'\n");
output("     LANGUAGE \'sql\'\n");
output("     !GO\n");
#Line 238
    Ast->bye();
}
output("\n");
#Line 240
    Ast->bye();
}
#Line 241
    Ast->bye();
}
output("  \n");
#Line 243
    Ast->bye();
}
Ast->bye();
close(F);
unlink ($tmp_file);

sub open_file {
    my ($a_file, $a_nooverwrite, $a_only_if_different, $a_append) = @_;

    #First deal with the file previously opened
    close (F);
    if ($only_if_different) {
        if (JeevesUtil::compare ($orig_file, $curr_file) != 0) {
            rename ($curr_file, $orig_file) || 
            die "Error renaming $curr_file  to $orig_file";
        }
    }

    #Now for the new file ...
    $curr_file = $orig_file = $a_file;
    $only_if_different = ($a_only_if_different && (-f $curr_file)) ? 1 : 0;
    $no_overwrite = ($a_nooverwrite && (-f $curr_file))  ? 1 : 0;
    $mode =  ($a_append) ? ">>" : ">";

    if ($only_if_different) {
        unlink ($tmp_file);
        $curr_file = $tmp_file;
    }

    if (! $no_overwrite) {
        open (F, "$mode $curr_file") || die "could not open $curr_file";
    }
}

sub output {
    print F @_ if (! $no_overwrite) 
}
1;
