#define LOGGER_FIFO "/tmp/logger"
#define FIFO_MODE 0700

#define MAX_MESSAGE_SIZE 8000
/* for area_name, class_name, method_name identifiers: */
#define MAX_NAME_SIZE 128
/* size of id or level written as string */
#define MAX_INT_SIZE 15

/* BUFFER_SIZE should be big enough to contain
id_log_request|log_level|area|class|method|message beginning
i.e. 2*(MAX_INT_SIZE+1)+3*(MAX_NAME_SIZE+1)
*/
#define BUFFER_SIZE (2*(MAX_INT_SIZE+1)+3*(MAX_NAME_SIZE+1))

/* CHAR_SEPARATOR separates input fields (single char) */
#define CHAR_SEPARATOR '|'

#define DB_CONNECTION_STRING "dbname=nobody"

#define MAX_QUERY_LEN 8100