/* JavaScript wrapper for methods of class generic_2d */

    /* METHOD: showFormFind2D*/
    function generic_2d_check_acl2d(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'check_acl2d' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.check_acl2d = generic_2d_check_acl2d;


    function generic_2d_get2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'get2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.get2D = generic_2d_get2D;


    function generic_2d_getByProp2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
    	    ,
	    arg_prop_name /* CO_STRING */
    	    ,
	    arg_prop_val /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getByProp2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );
	method.setParam( 'prop_name', String(arg_prop_name) );
	method.setParam( 'prop_val', String(arg_prop_val) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getByProp2D = generic_2d_getByProp2D;


    function generic_2d_update2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_par_prop /* CO_STRING */
    	    ,
	    arg_new_value /* CO_STRING */
    	    ,
	    arg_version /* CO_INTEGER */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'update2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'par_prop', String(arg_par_prop) );
	method.setParam( 'new_value', String(arg_new_value) );
	method.setParam( 'version', Number(arg_version) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.update2D = generic_2d_update2D;


    function generic_2d_insertChild2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_child_class /* CO_STRING */
    	    ,
	    arg_child_prop /* CO_STRING */
    	    ,
	    arg_foreign_prop /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'insertChild2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'child_class', String(arg_child_class) );
	method.setParam( 'child_prop', String(arg_child_prop) );
	method.setParam( 'foreign_prop', String(arg_foreign_prop) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.insertChild2D = generic_2d_insertChild2D;


    function generic_2d_select2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
    	    ,
	    arg_get_class_names /* CO_ARRAY_OF_STRINGS */
    	    ,
	    arg_get_prop_names /* CO_ARRAY_OF_STRINGS */
    	    ,
	    arg_filter_class_names /* CO_ARRAY_OF_STRINGS */
    	    ,
	    arg_filter_prop_names /* CO_ARRAY_OF_STRINGS */
    	    ,
	    arg_filter_operators /* CO_ARRAY_OF_STRINGS */
    	    ,
	    arg_filter_values /* CO_ARRAY_OF_STRINGS */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'select2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );
	method.setParam( 'get_class_names', (arg_get_class_names) );
	method.setParam( 'get_prop_names', (arg_get_prop_names) );
	method.setParam( 'filter_class_names', (arg_filter_class_names) );
	method.setParam( 'filter_prop_names', (arg_filter_prop_names) );
	method.setParam( 'filter_operators', (arg_filter_operators) );
	method.setParam( 'filter_values', (arg_filter_values) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.select2D = generic_2d_select2D;


    function generic_2d_getRelatedClasses2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getRelatedClasses2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getRelatedClasses2D = generic_2d_getRelatedClasses2D;


    function generic_2d_getRelatedData2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
    	    ,
	    arg_related_class /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getRelatedData2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );
	method.setParam( 'related_class', String(arg_related_class) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getRelatedData2D = generic_2d_getRelatedData2D;


    function generic_2d_getSchema2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callback /* CO_STRING */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getSchema2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callback', String(arg_callback) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getSchema2D = generic_2d_getSchema2D;


    function generic_2d_getWithSchema2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callbacks /* CO_ARRAY_OF_STRINGS */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getWithSchema2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callbacks', (arg_callbacks) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getWithSchema2D = generic_2d_getWithSchema2D;


    function generic_2d_getSchemaRelatedAndData2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_callbacks /* CO_ARRAY_OF_STRINGS */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getSchemaRelatedAndData2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'callbacks', (arg_callbacks) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getSchemaRelatedAndData2D = generic_2d_getSchemaRelatedAndData2D;


    function generic_2d_getForRelatedSchemaAndData2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
    	    ,
	    arg_related_class /* CO_STRING */
    	    ,
	    arg_callbacks /* CO_ARRAY_OF_STRINGS */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'getForRelatedSchemaAndData2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );
	method.setParam( 'related_class', String(arg_related_class) );
	method.setParam( 'callbacks', (arg_callbacks) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.getForRelatedSchemaAndData2D = generic_2d_getForRelatedSchemaAndData2D;


    function generic_2d_showForm2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'showForm2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.showForm2D = generic_2d_showForm2D;


    function generic_2d_showFormFind2D(
	    arg_par_area /* CO_STRING */
    	    ,
	    arg_par_class /* CO_STRING */
    	    ,
	    arg_par_id1 /* CO_INTEGER */
    	    ,
	    arg_par_id2 /* CO_INTEGER */
	)
    {
	var method = new COMethod( this.strArea, this.strClass, 'showFormFind2D' );

	method.setParam( 'par_area', String(arg_par_area) );
	method.setParam( 'par_class', String(arg_par_class) );
	method.setParam( 'par_id1', Number(arg_par_id1) );
	method.setParam( 'par_id2', Number(arg_par_id2) );

	method.call();

	return co_getretAny();
    }


	generic_2d.prototype.showFormFind2D = generic_2d_showFormFind2D;



  
