 
type CO_INTEGER
 {
   c_type int;
   sql_type int;
   js_type Number;
   pointer 0;
   is_array 0;
 };
	      
type CO_STRING
 {
   c_type char*;
   sql_type text;
   js_type String;
   pointer 1;
   is_array 0;
 };
 
type CO_ARRAY_OF_STRINGS
 {
   c_type char**;
   sql_type ****WRONG****;
   js_type '';
   pointer 1;
   is_array 1;
 };    
			  
type CO_STRING_SQL_VALUE
 {
   c_type char*;
   sql_type ****WRONG****;    
   js_type String;
   pointer 1;
   is_array 0;
 };

type CO_BOOL
 {
   c_type bool;
   sql_type bool;
   js_type Boolean;
   pointer 0;
   is_array 0;
 };

type CO_DATE
 {
  c_type char*;
  sql_type date;
  js_type Date;
  pointer 1;
  is_array 0;
 };

type CO_REAL
 {
  c_type float; 
  sql_type float4; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

type CO_NUMERIC
 {
  c_type float; 
  sql_type numeric; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

















 

class generic_2d

{
  area "_";
  area "sec";
  area "sys";
  area "usr";

  inherits 0;

  container_class '';
  container_column_name '';

  

  prop id1
  {
    type CO_INTEGER;
    default 0;
    params "READONLY=1";
    representant 1;
    foreign '';
    foreign_prop '';
    position 0;
  };

  prop id2
  {
    type CO_INTEGER;
    default 0;
    params "READONLY=1";
    representant 1;
    foreign '';
    foreign_prop '';
    position 0;
  };

  prop version
  {
    type CO_INTEGER;
    default 0;
    params "READONLY=1";
    representant 1;
    foreign '';
    foreign_prop '';
    position 0;
  };

  prop deleted
  {
    type CO_INTEGER;
    default 0;
    params "READONLY=1";
    representant 1;
    foreign '';
    foreign_prop '';
    position 0;
  };

  include_c "../generic_acl/co_generic_acl.h";

 

  method check_acl2d
  {
    id_permission 0;
    
    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
    
    declare language_c
    {
      C
      %%
      char *container_class;
      char *container_column_name;
      int container_id;
      %%
      ;
    };

    body language_c
    {
      C
      %%
      __CREATE_QUERY("SELECT container_class, container_column_name FROM co_%s_meta_class WHERE class_name='%s'", par_area, par_class)
      container_class = ap_pstrdup(p,PQgetvalue(res,0,0));
      container_column_name = ap_pstrdup(p,PQgetvalue(res,0,1));
      __SQL_GET_RESULT
      __CLEAR_RESULT

      __CREATE_QUERY("SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d", container_column_name, par_area, par_class, par_id1, par_id2)
      __SQL_GET_RESULT
      container_id = atoi(PQgetresult(res,0,0));
      __CLEAR_RESULT
      
      @co_call(par_area,container_class,"check_acl", par_area=>par_area,par_class=>container_class,par_id=>container_id,callback=>"\"\"");

      %%
      ;
    };
  };

  method get2D
  {
   id_permission 0;

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 

    body language_c
      {
         C
	 %%
         __INIT_VARIABLES
	 cou_sendMessageX(cnx, "entering get", CO_MSG_DEBUG);
         __CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id1=%d AND id2=%d" , par_area, par_class, par_id1, par_id2)
	 cou_sendMessageX(cnx, "get sql string:", CO_MSG_DEBUG);
	 cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);
         __GET_RESULT_AND_CREATE_JS
	 cou_sendMessageX(cnx, "leaving get", CO_MSG_DEBUG);
	 %%
	 ;
      };
  };

  method getByProp2D
  {
   id_permission 0;

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 

    param prop_name {type CO_STRING;};
    param prop_val {type CO_STRING;};

    body language_c
      {
         C
         %%
          cou_sendMessageX(cnx, ap_psprintf(p,"client_mode: %d", cnx->client_mode), CO_MSG_DEBUG);
          __CREATE_QUERY("SELECT * FROM co_%s_%s WHERE %s='%s'" , par_area, par_class, prop_name, prop_val)
	  cou_sendMessageX(cnx, "getByProp sql string:", CO_MSG_DEBUG);
	  cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);
         __GET_RESULT_AND_CREATE_JS
         %%
         ;
      };
  };

 method update2D
 {
   id_permission 1;

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
    param par_prop { type CO_STRING; };
    param new_value { type CO_STRING; };
    param version{ type CO_INTEGER; };

    declare language_c
    {
      C
      %%
      int cur_version;
      char *new_value_coded;
      char* puta_classes[2]={NULL,NULL};
      int puta_ids[2]={0,0};  
      %%
      ;
    };

    body language_c
    {
      C
      %%
       __INIT_VARIABLES

      new_value_coded = cou_buildEncodedSQL(cnx, new_value);

      __CREATE_QUERY("SELECT version FROM co_%s_%s WHERE id1=%d AND id2=%d",par_area, par_class, par_id1, par_id2)

      __SQL_GET_RESULT
      cur_version= atoi(PQgetvalue(res, 0, 0));
      __CLEAR_RESULT
      memset(SQLString, 0, SQLBUFSIZE);
      
      if(version != cur_version) 
      {
        cou_sendMessage(cnx, "Nie poprawilismy danych bo miales stary obraz! (bez obrazy :-)");
	return -1;
      };

      __CREATE_QUERY("UPDATE co_%s_%s SET %s=\'%s\', version=version+1 WHERE id1=%d AND id2=%d",
              par_area, par_class, par_prop, new_value_coded, par_id1, par_id2)
      __SQL_EXEC

      puta_classes[0] = par_class;
      puta_ids[0] = par_id;
      
      cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_UPDATE, par_prop, new_value, NULL);
      cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_UPDATE, "version",ap_psprintf(p,"%d",cur_version+1),NULL);
      %%
      ;
    };
   };

 method insertChild2D
 {
    id_permission 6;

    doc "this is method for inserting object into container. You can specify class_name of child element";

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
    param child_class
         {
           type CO_STRING;
           doc "this is the name of class tu insert record in";
         };
    param child_prop
        {
           type CO_STRING;
           doc "this is the property name in child class that holds id of parent";
        };
    param foreign_prop
       {
           type CO_STRING;
           doc "this is the prop in container (this:) class that holds id to copy to child class";
       };

    declare language_c
    {
      C
      %%
        int new_id=0;
	int i;
	int nFields;
        char* puta_classes[3]={NULL,NULL,NULL};
	int puta_ids[3]={0,0,0};  
	char **props;
      %%
      ;
    };

    body language_c
    {
      C
      %%
      __INIT_VARIABLES
      __CREATE_QUERY("INSERT INTO co_%s_%s (%s) SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d",
                           par_area, child_class, child_prop, foreign_prop, par_area, par_class, par_id1, par_id2)

      cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);

      __SQL_EXEC

      __CREATE_QUERY("SELECT last_value FROM co_%s_%s_sqid", par_area, child_class)
      __SQL_GET_RESULT
      new_id= atoi(PQgetvalue(res, 0, 0));
      __CLEAR_RESULT

      cou_sendMessageX(cnx, "insertChild done", CO_MSG_DEBUG);

      puta_classes[0] = par_class;
      puta_ids[0] = par_id;

      puta_classes[1] = child_class;
      puta_ids[1] = new_id;

      cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_INSERT, "child_class", child_class,NULL);

       

      __CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id = %d", par_area, child_class, new_id);

      __SQL_GET_RESULT

      puta_classes[0] = child_class;
      puta_ids[0] = new_id;

      puta_classes[1] = par_class;
      puta_ids[1] = par_id;

      puta_classes[2] = NULL;
      puta_ids[2] = 0;

      nFields = PQnfields(res);
      props = ap_palloc(p, 2 * nFields * sizeof(char*) + 1);

      for (i = 0; i < nFields; i++)
      {
	 props[2*i] = ap_pstrdup(p, PQfname(res, i));
	 props[2*i+1] = ap_pstrdup(p, PQgetvalue(res, 0, i));
      } 
      props[2*i]=NULL;
      
       
      
      __CLEAR_RESULT
      cou_queueActionXX( cnx, child_class, puta_classes, puta_ids, CO_OP_UPDATE, props);
      cou_setReturnValue(cnx, &new_id, CO_INTEGER);
      
      %%
      ;
    };
   };

 method select2D
  {
    doc "Gets recordset of objects on given filter rule";
    
    id_permission 2;

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 
    param get_class_names {type CO_ARRAY_OF_STRINGS;};
    param get_prop_names {type CO_ARRAY_OF_STRINGS;};
    param filter_class_names {type CO_ARRAY_OF_STRINGS;};
    param filter_prop_names {type CO_ARRAY_OF_STRINGS;};
    param filter_operators {type CO_ARRAY_OF_STRINGS;};
    param filter_values {type CO_ARRAY_OF_STRINGS;};
    
    declare language_c
    {
      C
      %%
       int get_col_num, filter_col_num;
       int sql_from_start,i;
       char column_value_coded[FIELDBUFSIZE];
       char column_value_js_encoded[FIELDBUFSIZE];
      %%
      ;
    };

    body language_c
    {
      C
      %%
      __INIT_VARIABLES;

      memset(column_value_coded,0,FIELDBUFSIZE);
      memset(column_value_js_encoded,0,FIELDBUFSIZE);

      snprintf(SQLString,SQLBUFSIZE, "SELECT ");

      if(get_class_names[0])
      { 
         sprintf(SQLString + strlen(SQLString), " co_%s_%s.%s ", par_area, get_class_names[0], get_prop_names[0]);
      }
      i=1;
      while(get_class_names[i])
      {
        sprintf(SQLString + strlen(SQLString), " , co_%s_%s.%s ", par_area, get_class_names[i], get_prop_names[i]);
        i++;
      };

      sql_from_start = strlen(SQLString);
      sprintf(SQLString + strlen(SQLString), " FROM co_%s_%s ", par_area, get_class_names[0]);
      i=1;
      while(get_class_names[i])
      { 
         
       if(0==strstr(SQLString+sql_from_start, get_class_names[i]))
       { 
         sprintf(SQLString + strlen(SQLString), " , co_%s_%s ", par_area, get_class_names[i]);
       };
       i++;
      };

      sprintf(SQLString + strlen(SQLString), " WHERE co_%s_%s.%s %s \'%s\' ", par_area,
                    filter_class_names[0], filter_prop_names[0],filter_operators[0], filter_values[0]);
      i=1;
      while(filter_prop_names[i])
      {
         sprintf(SQLString + strlen(SQLString), " AND co_%s_%s.%s %s \'%s\' ",par_area,
                 filter_class_names[i], filter_prop_names[i],filter_operators[i], filter_values[i]);
         i++;
      };

      cou_logError( cnx, CO_LOG_DEBUG, "SELECT SQL:");
      cou_logError( cnx, CO_LOG_DEBUG, SQLString);

      __GET_RESULT_AND_CREATE_JS
      %%
      ;
      
    };
  };

  method getRelatedClasses2D
   {
      doc "retrieves names of related classes and foreign column names for given class";

     id_permission 5;

    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 

       body language_c
        {
          C
	  %%
	  __INIT_VARIABLES
          __CREATE_QUERY("SELECT class_name, prop_name, prop_foreign_prop FROM co_%s_meta_prop WHERE prop_foreign=\'%s\'", par_area, par_class);
          __GET_RESULT_AND_CREATE_JS
	  %%
	  ;
       };
   };

  method getRelatedData2D
   {
      doc "retrieves data of related class";

     id_permission 5;
     
    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 
     param related_class {type CO_STRING;}; 

     declare language_c
     {
       C
       %%
       char * foreign_prop;
       char * foreign_val;
       char * rel_prop;
       %%
       ;
     };
       
     body language_c
     {
       C 
	  %%
	  __INIT_VARIABLES
	  
	   
	  
          __CREATE_QUERY("SELECT prop_name, prop_foreign_prop FROM co_%s_meta_prop WHERE prop_foreign='%s' and class_name='%s'",
                    par_area, par_class, related_class)
	  __SQL_GET_RESULT	    
	  
	  if(PQntuples(res)>0)
	  {
	    rel_prop = ap_pstrdup(r->pool, PQgetvalue(res, 0, PQfnumber(res,"prop_name"))); 
	    foreign_prop = ap_pstrdup(r->pool, PQgetvalue(res, 0, PQfnumber(res,"prop_foreign_prop")));
	  }
	  else
	  {
	    cou_sendMessage(cnx, ap_psprintf(p, "GENERIC_2D::getRelatedData : could not find related prop for area:'%s' class:'%s' related_class:'%s'",
	                                         par_area,par_class, related_class));
	    return -1;
	  };
	      
          __CLEAR_RESULT
	  
	   
          __CREATE_QUERY("SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d", foreign_prop, par_area, par_class, par_id1, par_id2);
		    
	  __SQL_GET_RESULT
	  
	  if(PQntuples(res)>0)
	  {
	    foreign_val = ap_pstrdup(p, PQgetvalue(res, 0, 0)); 
	  }
	  else
	  {
	    cou_sendMessage(cnx, ap_psprintf(p, "GENERIC_2D::getRelatedData : could not find record for area:'%s' class:'%s' par_id1:%d par_id2:%d",
	                                         par_area,par_class, par_id1, par_id2));
	    return -1;
	  };

	  __CLEAR_RESULT

	   
          __CREATE_QUERY("SELECT * FROM co_%s_%s WHERE %s='%s'", par_area, related_class, rel_prop, foreign_val);

          __GET_RESULT_AND_CREATE_JS
	  %%
	  ;
     };
   };

 method getSchema2D
   {
      doc  "Retrieves schema for given class";

    id_permission 3;
    
    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";}; 

      body language_c
       {
          C
	  %%
	  __INIT_VARIABLES
	  __CREATE_QUERY("SELECT * FROM co_%s_meta_prop WHERE class_name=\'%s\' ", par_area,par_class);
	  __GET_RESULT_AND_CREATE_JS
	  %%
	  ;
       };
   };

 method getWithSchema2D
   {
    doc  "Retrieves schema for given class";

    id_permission 3;

     param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
     param callbacks { type CO_ARRAY_OF_STRINGS; };

     body language_c
       {
          C
	  %%
	  __INIT_VARIABLES
	  @co_call(par_area,par_class,"getSchema",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>"callbacks[0]");
	  @co_call(par_area,par_class,"get",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>"callbacks[1]");
	  %%
	  ;
       };
   };

 method getSchemaRelatedAndData2D
   {
    doc  "Retrieves schema related tables and data for given class element";

    id_permission 3;

     param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
     param callbacks { type CO_ARRAY_OF_STRINGS; };

     body language_c
       {
          C
	  %%
	  __INIT_VARIABLES

	   

	  @co_call(par_area,par_class,"getSchema",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>"callbacks[0]");
	  @co_call(par_area,par_class,"getRelatedClasses",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>"callbacks[1]");
	  @co_call(par_area,par_class,"get",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>"callbacks[2]");
	  %%
	  ;
       };
   };

 method getForRelatedSchemaAndData2D
   {
    doc  "Retrieves schema related tables and data for given class element";

    id_permission 3;
    
    param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 
    param related_class {type CO_STRING;}; 
    param callbacks { type CO_ARRAY_OF_STRINGS; };

    body language_c
    {
        C 
	%%
	__INIT_VARIABLES
	  
	 
	  
        @co_call(par_area,related_class,"getSchema", par_area=>par_area,par_class=>related_class,par_id=>par_id,callback=>"callbacks[0]");	  
        @co_call(par_area,par_class,"getRelatedData",par_area=>par_area,par_class=>par_class,par_id=>par_id,related_class=>related_class,callback=>"callbacks[1]");
	%%
	;
    };
   };

 method showForm2D
   {

     id_permission 4;

     param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 

     declare language_c
      {
        C
	%%
	FILE *fh;
	int c;
	const char* root_path;
        long len;
        int user_id=1;
	%%
	;
      };

     body language_c
      {
        C
	%%
	root_path = cou_getCORootPath( cnx );
	fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic", "_head.html", NULL), "r");
        if (!fh) cou_error( cnx, "Head file not found");
        cou_logError( cnx, CO_LOG_DEBUG, "sending head" );
        ap_rputs("<HEAD>\n", r);
        ap_kill_timeout(r);
	len = ap_send_fd( fh, r );  
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Head sent: %d bytes", len);
	ap_pfclose(p,fh);
	cou_logError( cnx, CO_LOG_DEBUG, "sending script" );
	ap_rputs("<SCRIPT>\n", r);
	
	ap_rprintf( r, "var  id_session = %d;\n", cou_assignNewSession( cnx ) );
	ap_rprintf( r, "var  par_id = %d;\n", par_id );
	ap_rprintf( r, "var  par_class=\'%s\';\n", par_class );
	ap_rprintf( r, "var  par_area = \'%s\';\n", par_area );
	ap_rprintf( r, "var  debug_level = %d;\n", cnx->debug_level );

        ap_rputs("</SCRIPT>\n", r);

        ap_rputs("</HEAD>\n", r);
        fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic", "_body.html", NULL), "r");
        if (!fh) cou_error( cnx, "Body file not found");
        cou_logError( cnx, CO_LOG_DEBUG, "sending body" );
        ap_rputs("<BODY>\n", r);
        len = ap_send_fd( fh, r );  

        if (r->connection->aborted) ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "connection aborted");
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "bytes_send=%d", r->bytes_sent);

        ap_soft_timeout("finish request", r);

        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Body sent: %d bytes", len);

        ap_pfclose(p,fh);
        ap_rputs("</BODY>\n", r);

        ap_rflush(r);
	%%
	;
    };
  };

 method showFormFind2D
   {

     id_permission 4;

     param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; }; 

     declare language_c
      {
        C
	%%
	FILE *fh;
	int c;
	const char* root_path;
	long len;
	int user_id;
	%%
	;
      };

     body language_c
      {
        C
	%%
	user_id = cnx->user_id;
	root_path = cou_getCORootPath( cnx );

	fh = ap_pfopen(r->pool, ap_pstrcat( p, root_path, "/forms/", "generic_f", "_head.html", NULL), "r");
        if (!fh) cou_error( cnx, "Head file not found");
        cou_logError( cnx, CO_LOG_DEBUG, "sending head" );
        ap_rputs("<HEAD>\n", r);
        ap_kill_timeout(r);

        len = ap_send_fd( fh, r );  
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Head sent: %d bytes", len);

        ap_pfclose(p,fh);

        cou_logError( cnx, CO_LOG_DEBUG, "sending script" );
        ap_rputs("<SCRIPT>\n", r);

	ap_rprintf( r, "var  id_session = %d;\n", cou_assignNewSession( cnx ) );
	ap_rprintf( r, "var  par_id = %d;\n", par_id );
	ap_rprintf( r, "var  par_class=\'%s\';\n", par_class );
	ap_rprintf( r, "var  par_area = \'%s\';\n", par_area );
	ap_rprintf( r, "var  debug_level = %d;\n", cnx->debug_level );

        ap_rputs("</SCRIPT>\n", r);

        ap_rputs("</HEAD>\n", r);
        fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic_f", "_body.html", NULL), "r");
        if (!fh) cou_error( cnx, "Body file not found");
        cou_logError( cnx, CO_LOG_DEBUG, "sending body" );
        ap_rputs("<BODY>\n", r);
        len = ap_send_fd( fh, r );  

        if (r->connection->aborted) ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "connection aborted");
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "bytes_send=%d", r->bytes_sent);

        ap_soft_timeout("finish request", r);

        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Body sent: %d bytes", len);

        ap_pfclose(p,fh);
        ap_rputs("</BODY>\n", r);

        ap_rflush(r);
	%%
	;
    };
  };
};

 
