#include "types.t"
   
class log_request
{

	area sys
	{
		force_sec_type 1;
	};

#include "check_acl.t"
   
	inherits generic_acl;
   
	container_class '';
	container_column_name '';

#include "generic_acl_props.t"

   prop id_session
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1000;
   };
   
   prop request_num
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1100;
   };

   prop remote_host
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1110;
   };
 
   prop user
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1120;
   };

   prop request
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1150;
   };
 
   prop end_logged
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1200;
   };
   
   prop starttime
   {
     type CO_TIMESTAMP;
     default "CURRENT_TIMESTAMP";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1300;
   };
 
   prop endtime
   {
     type CO_TIMESTAMP;
     default "'1900-01-01'";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1400;
   };
 
   prop state
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1500;
   };

   prop size
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1600;
   };
};  
