//--------------- This two functions are in common.js:
//clears tag
function clear(div)
{
   while(div.hasChildNodes())
  {
       var child = div.firstChild;
        div.removeChild(child);
   };
};
		    
function objToString(o)
{
  var ret = new String();
  for(var f in o)
 {
   if(typeof(o[f]) == "object")
   {
     ret+= f.toString() + "->" + objToString(o[f]);
   }
   else
   {
      ret += f.toString()+":"+o[f]+";";
   };
 };
 return ret;
};
		  
//-----------------END OF LIBRARY  
// jump to TREE
var application_id = 1;
var id_root= par_id;
var image_path = "/co/images/";

var top_window, left_window, right_window, resize, debug;
var STYLE = " style='cursor:hand; font-weight:; font-size:x-small;face:arial' ";
var STYLE2 = " style='cursor:hand; font-weight:; font-size:x-small;color:black' ";
var window_id = 1;

var active_id = 0;
var active_class_name = 0;

var active_catalog = 0;
var active_path = new String();
var active_item_path = new String();
var active_parents = new String();
var active_item = 0;
var active_item_version =0;
var active_catalog_actions = new Array();
var active_catalog_items;
var right_window_sort_column = "name";
var right_window_sort_column_id = 1;

var active_color_background = "CCCC99";																													// tlo podswietlenia w lewym oknie nawigacji
var active_color_font = "black";																														  // kolor zaznaczenia pliku w prawej ramce

//var inactive_color_background = "002F55";  // tlo do menu z nawigacja 
var inactive_color_background = "999966";      																									
var inactive_color_font = "black";

var dragapproved=false;		//dragging started
var resizeapproved = false;	//resizing started
var resize;			//image to act as handler in window resizing
var z, drager;			// z holds data in drag & drop, d is object to drag
var debug;			//used for debbuging

///////////////////////////////////////////////////////////////////
// this is drag&drop implementation

function move()
{
/*
	if (event.button==1&&dragapproved)
	{
		drager.style.pixelLeft=event.x;
		drager.style.pixelTop=event.y;
		drager.style.visibility="visible";
		
		//debugAlert(d.style.pixelTop);
		 
		var evid = event.srcElement.id.substring(0,2);
		if (evid!="SC")
		{
			drager.style.color="red";
		}
		else
		{
			drager.style.color="black";
		};
		return false;
	};
*/
}

function drag()
{
/*
	// IE only:
    var evid = event.srcElement.id.substring(0,2);
	// mozilla???

	if (evid=="SC" || evid=="SI")
	{
	
		dragapproved=true;
		z=event.srcElement;
		drager.style.pixelLeft=event.x;
		drager.style.pixelTop=event.y;
		drager.innerHTML=z.innerHTML;
		document.onmousemove=move;
	}
*/	
}

function drop()
{
/*
    if(dragapproved)
    {
		dragapproved=false;
		drager.style.visibility="hidden";
		//debugAlert(event.srcElement.outerHTML);
		var evid = event.srcElement.id.substring(0,2);
		if (evid=="SC")
		{
		   var ids= z.id.slice(2);
		   var idt= event.srcElement.id.slice(2);
		   if(ids != idt) catalog_moveItemByID(ids,idt);
		};
	}

*/
};

document.onmousedown=drag;
document.onmouseup=drop;


///////////////////////////////////////////////////////////////////
// Required functions

function co_refresh(o)
{
}

function co_insert(o)
{
}

function co_undelete(o)
{
}

function co_delete(o)
{
}

///////////////////////////////////////////////////////////////////
// library of functions used by server

// these are widths for columns in left window, there are the same like for the header id = IDX*
// look for HTML at the end of this file
var arr_rightListWidth = new Array(5,200,10,200,10);


// hepler function to create cells
function h_create_cell(tr, index)
{
  var td = tr.insertCell(index);
  td.className = "rightList";
 
  // last cell has no width specified
  if(index<5)
  {
      td.width = arr_rightListWidth[index];
  }

//  var idx = "COLX" + index; 
//  td.width = document.body.all[idx].offsetWidth;

  return td;
}; 

function catalog_showItems(cat_items)
{
   active_catalog_items = cat_items;
   var props = cat_items.d;
    
   var tab = document.createElement("TABLE");
// IE:
   tab.className = "leftSide";
   tab.border = 0;
   tab.cellSpacing = 0;

//old:   var spacja = document.createTextNode(" ");
   var spacja = document.getElementById("spacja");
   // we assume that id is given
   for(i=0; i< props["id"].length; i++)
   {
        var tr = tab.insertRow(2*i); // we have one row plus with description
        tr.className = "itemLine";
        tr.id = "RIGHT"+props["id"][i];
        tr.priv_obj_id = props["id"][i];
        tr.priv_version = props["version"][i];
        tr.onclick= function() {catalog_selectRight(this.priv_obj_id);}; 

        // cell to keep margin 
        var td = h_create_cell(tr,0);
        td.appendChild(spacja.cloneNode(true));

        //cell with icon 
        td = h_create_cell(tr,1);
		td.align="center";
        var img = document.createElement("IMG");
		img.className = "imageLeftList";
        img.src =  image_path + "other/" + props["type_class_name"][i] + ".gif";
        img.alt =               props["type_class_name"][i];
        td.appendChild(img);

        // margin
        td = h_create_cell(tr,2);
        td.appendChild(spacja.cloneNode(true));

        // cell with name  
        td = h_create_cell(tr,3);
        td.id = "TDR" +props["id"][i];
        var id="SI"+props["id"][i];
	if(props["type_container"][i]==1) id="SC"+props["id"][i];
        var span = document.createElement("SPAN");
        span.id = id;
        var text = document.createTextNode( props["name"][i] );
        span.appendChild(text);
        td.appendChild(span); 
        
        // margin
        td = h_create_cell(tr,4);
        td.appendChild(spacja.cloneNode(true));

        // cell with description 
        td = h_create_cell(tr,5);
        var span = document.createElement("SPAN");
        var text = document.createTextNode(props["creator"][i]);
        span.appendChild(text);
        td.appendChild(span); 

        // row with description 
        tr = tab.insertRow(2*i+1);
        // we create 4 empty rows and one for description
        for(var j=0; j<4; j++)
        {
           td = h_create_cell(tr,j);
           td.appendChild(spacja.cloneNode(false));
        };
        text = document.createTextNode( props["description"][i] );
        td.colSpan = 3;
        td.appendChild(text);
   };
   var r_window = document.getElementById("RIGHT_WINDOW");
   clear(r_window);
   r_window.appendChild(tab);
};

function catalog_showCatPath(path)
{
    var ot = document.createTextNode("   " + path);
    var cat_p = document.getElementById("CAT_PATH");
    clear(cat_p);
    cat_p.appendChild(ot);
    active_path = path;
};

function catalog_showItemPath(path)
{
   // ITEM_PATH.innerText = "  " + path;
   // alert("ustawiam item_path na:" + path);
    active_item_path = path;
};

function catalog_showDelete(side, item_id, nic)
{
        //alert("jestem w showDelete");

	if(side == "right")
	{
		catalog_changeActive(active_catalog, active_catalog_parent, 1);
		var tb_id = "TAB" + item_id;
		if (document.getElementById(tb_id) != null)
		{
			var tbd = document.getElementById(tb_id);
			tbd.outerHTML=" ";
		};
	};
};

function catalog_showAdd(side)
{
	if(side == "right")
	{
		catalog_changeActive(active_catalog, active_catalog_parent, 1);
	}
	
};


function catalog_setParents(parents)
{
	active_parents = parents;
};

function new_window(param)
{
	hr = location.href;
	var li = hr.lastIndexOf("/");
	var url= hr.slice(0, li);
	url+= "/" + param + urlEncode("active",active_catalog) +  urlEncode ("active_path", active_path);
	url += urlEncode("side","left");
	window.open(url, session_id + "WW" + window_id, "toolbar=0,menubar=0,resizable=1,scrollbars=1");
	window_id ++;
}

function new_window2(param)
{
	hr = location.href;
	var li = hr.lastIndexOf("/");
	var url= hr.slice(0, li);
	url+= "/" + param + urlEncode("catalog",active_catalog) + urlEncode("active",active_item) +  urlEncode ("active_path", active_item_path);
	url += urlEncode("side","right");
	window.open(url, session_id + "WW" +window_id, "toolbar=0,menubar=0,resizable=1,scrollbars=1");
	window_id++;
}

/////////////////////////////////////////////////////////////////////
// events methods

function catalog_getItems(cat_id)
{
    var param = par_class+"?unfoldCatalog&";
    param += urlEncode("par_class", par_class);
    param += urlEncode("par_id", cat_id);
    param += urlEncode("filter_type", 0);
//    param += urlEncode("sort_prop", "");
//  param += urlEncode("sort_column", right_window_sort_column);
    param += urlEncode("callback", "catalog_showItems(");
    debugAlert(param);
    PutRequest(param);
    
};

function catalog_getParents(cat_id)
{
        var param = par_class+"?getParents&";
        param += urlEncode("par_area", par_area);
        param += urlEncode("par_class", par_class);
        param += urlEncode("par_id", cat_id);
        param += urlEncode("id_root", id_root);
	param += urlEncode("callback", "catalog_setParents(" );
	debugAlert(param);
	PutRequest(param);
};


function catalog_changeActive(cat_id, cat_parent_id, uncheck)
{

	if((active_catalog !=0) && (cat_id != active_catalog) && uncheck)
	{
		var id="TAB" + active_catalog;
		var td = document.getElementById(id);
//ie		td.children(0).children(0).style.background = inactive_color_background;
//ie		td.children(0).children(0).style.color = inactive_color_font;
		td.firstChild.firstChild.style.backgroundColor = inactive_color_background;
		td.firstChild.firstChild.style.color = inactive_color_font;
	}

	active_catalog = cat_id;
	active_catalog_parent = cat_parent_id;
	
	active_item = 0;
	//ITEM_PATH.innerHTML=" ";
	ITEM_FUNCTIONS.innerHTML="&nbsp;";
	
	var id="TAB" + cat_id;
	td = document.getElementById(id);
	td.firstChild.firstChild.style.backgroundColor = active_color_background;
	td.firstChild.firstChild.style.color = active_color_font;
	
	catalog_getItems(cat_id);
	catalog_getParents(cat_id);
	catalog_setFunctions(cat_id);
	catalog_setPath(cat_id);

};

function catalog_setPath(cat_id)
{
        var param = par_class+"?getFullPath&";
        param += urlEncode("par_area", par_area);
        param += urlEncode("par_class", par_class);
        param += urlEncode("par_id", cat_id);
        param += urlEncode("id_root", id_root);
	param += urlEncode("callback", "catalog_showCatPath(");
	debugAlert(param);
	PutRequest(param);
};

function catalog_setItemPath(item_id)
{
        var param = par_class+"?getFullPath&";
        param += urlEncode("par_area", par_area);
        param += urlEncode("par_class", par_class);
        param += urlEncode("par_id", item_id);
        param += urlEncode("id_root", id_root);
	param += urlEncode("callback", "catalog_showItemPath(");
	debugAlert(param);
	PutRequest(param);
};

function getParamsForLMenu()
{

  var ret  = urlEncode("active_area",  par_area);
      ret += urlEncode("active_class", par_class);
	  ret += urlEncode("active_catalog", active_catalog);
      ret += urlEncode("active_item", active_catalog);
      ret += urlEncode("active_path", active_path);
  //    ret += urlEncode("version", active_catalog_version);
  return ret;

/* in generic was:
      ret += urlEncode("deep_level", deep_level);
      ret += urlEncode("version", this.record_data["version"][0]);

        ret += urlEncode("context1", context1);
        ret += urlEncode("context2", context2);
        ret += urlEncode("context3", context3);
*/
};

function getParamsForRMenu()
{

  var ret  = urlEncode("active_area",  par_area);
      ret += urlEncode("active_class", par_class);
	  ret += urlEncode("active_catalog", active_catalog);
      ret += urlEncode("active_item", active_item);
      ret += urlEncode("active_path", active_item_path);
      ret += urlEncode("version", active_item_version);
  return ret;
};

function catalog_setFunctions(cat_id)
{
	arrMenus[0] = new menu(0, par_class, cat_id, document.getElementById("CAT_FUNCTIONS"), "left", "catalog");
    arrMenus[0].getParams = function() { return /*arrayObjectRecord[0].*/ getParamsForLMenu();};;
};



function catalog_setItemFunctions(item_id)
{
	arrMenus[1] = new menu(1, par_class, item_id, document.getElementById("ITEM_FUNCTIONS"), "right", "catalog");
    arrMenus[1].getParams = function() { return /*arrayObjectRecord[0].*/ getParamsForRMenu();};;

};

function catalog_selectRight(item_id)
{
        var tr_id="RIGHT" + item_id;
	var tr = document.getElementById(tr_id);
        tr.className = "itemLineActive";
        active_item_version = tr.priv_version;
	if((active_item !=0) && (item_id !=active_item))
	{
		tr_id="RIGHT" + active_item;
		tr = document.getElementById(tr_id);
                tr.className = "itemLine";
	};
	active_item = item_id;
        catalog_setItemFunctions(item_id);
	catalog_setItemPath(item_id);
};


// TODO: implement move as a single method

function catalog_setSortColumn(sort_col)
{
    var oldItemId = "RIGHTSORT"+right_window_sort_column;
    right_window_sort_column = sort_col;
    var newItemId = "RIGHTSORT"+right_window_sort_column;
    
    document.getElementById(oldItemId).style.fontStyle = "normal";
    document.getElementById(newItemId).style.fontStyle = "italic";
    
	var param = urlEncode("action_name", "open")
	param += urlEncode("component_name", "catalog");
	param += urlEncode("item_id", active_catalog);
	param += urlEncode("sort_column", right_window_sort_column);
	param += urlEncode("callback", "catalog_showItems(");
	debugAlert(param);
//	PutRequest(param);
};

// TREE
function tree_showItem(cat_class_name, cat_id)
{
	var src = '/co/html/sys/'+cat_class_name+'?showForm&par_id='+cat_id;
	if (is_ie5up) {
		right_window.src = src;
	} else {
		clear(right_window_parent);
		var iframe = document.createElement("IFRAME");
		iframe.setAttribute("id", "RIGHT_WINDOW");
		// XXX
		iframe.setAttribute("HEIGHT", "600");
		iframe.setAttribute("WIDTH", "600");
		//???	iframe.setAttribute("style", "height: 100%; width: 100%;");
		iframe.setAttribute("SRC", src);
		right_window_parent.appendChild(iframe);
		right_window = document.getElementById("RIGHT_WINDOW");
	}
}

function tree_changeActive(cat_class_name, cat_id, uncheck)
{
	if((active_id !=0) && (cat_id != active_id) && uncheck)
	{
		var id="TAB" + active_id + "_" + active_class_name;
		var td = document.getElementById(id);
		td.firstChild.firstChild.style.backgroundColor = inactive_color_background;
		td.firstChild.firstChild.style.color = inactive_color_font;
	}

	active_id = cat_id;
	active_class_name = cat_class_name;
	
	active_item = 0;
	//ITEM_PATH.innerHTML=" ";
	ITEM_FUNCTIONS.innerHTML="&nbsp;";
	
	var id="TAB" + cat_id + "_" + cat_class_name;
	td = document.getElementById(id);
	td.firstChild.firstChild.style.backgroundColor = active_color_background;
	td.firstChild.firstChild.style.color = active_color_font;

	tree_showItem(cat_class_name, cat_id);
/* XXX
	catalog_getItems(cat_id);
	catalog_getParents(cat_id);
	catalog_setFunctions(cat_id);
	catalog_setPath(cat_id);

*/
};


function tree_showFold(cat_class_name, cat_id)
{
	var idt = "TAB" + cat_id+"_"+cat_class_name;
	var tab = document.getElementById(idt);
	
	var idm = "IMG" + cat_id+"_"+cat_class_name;
	var img = document.getElementById(idm);
	
	
img.src = "/co/images/other/plus.gif";
	img.onclick = function () { tree_showUnfold(this.priv_cat_class_name,this.priv_cat_id); };
	
	tab.deleteRow(1);
/* XXX
	if(active_parents.indexOf("["+cat_id+"]") >= 0 )
	{
		catalog_changeActive(cat_id, cat_parent_id, 0);
	};
*/
}


function tree_showUnfold(cat_class_name, cat_id)
{
	var idt = "TAB" + cat_id +"_"+ cat_class_name;
	var tab = document.getElementById(idt);
	
	var idm = "IMG" + cat_id +"_"+ cat_class_name;
	var img = document.getElementById(idm);
	
	var new_row = tab.insertRow(tab.rows.length);
	var new_cell1 = new_row.insertCell(0);
	var new_cell2 = new_row.insertCell(1);

	// tabela z nawigacja (lewa) 
	var new_table = document.createElement("TABLE");
	new_table.id = "TABD" + cat_id +"_"+cat_class_name;
	new_table.style.cellSpacing=0 ;
	new_table.style.cellPadding=0 ;
	new_table.style.border=0 ;
	new_cell2.appendChild(new_table);
	new_table.style.backgroundColor=inactive_color_background;

	
img.src = "/co/images/other/minus.gif";
	img.onclick = function () { tree_showFold( this.priv_cat_class_name, this.priv_cat_id ); };

	// get rows for TABD
	tree_getRows(tree_name, cat_class_name, cat_id);
}

// used for callback:
function client_insertRows(tree_name, parent_class_name, parent_id, o)
{
	//alert("client_insertRows: "+objToString(o));
	var i;
	for(i=0; i<o.d.id.length; i++) {
		var rows = o.d;
		add_cat_item(rows["name"][i], rows["class"][i], rows["id"][i], parent_class_name, parent_id);
	}
}

function tree_getRows(tree_name, parent_class_name, parent_id)
{
	var meta_tree_getChildren = new COMethod('sys', 'meta_tree', 'getChildren');
	meta_tree_getChildren.setParam("par_id", -1);
	meta_tree_getChildren.setParam("tree_name", tree_name);
	meta_tree_getChildren.setParam("parent_class_name", parent_class_name);
	meta_tree_getChildren.setParam("parent_id", parent_id);
	meta_tree_getChildren.call("client_insertRows", tree_name, parent_class_name, parent_id);
}

function tree_setRoot(parent_class_name, parent_id)
{
	var tab = document.createElement("TABLE");
	tab.id = "TABD"+parent_id+"_"+parent_class_name;
	tab.className = "leftSide";
	left_window.appendChild(tab);
}

function init()
{
	top_window = document.getElementById("TOP_WINDOW");
	left_window = document.getElementById("LEFT_WINDOW");
	right_window = document.getElementById("RIGHT_WINDOW");
	right_window_parent = document.getElementById("RIGHT_WINDOW_PARENT");
	resize = document.getElementById("RESIZE");
	debug = document.getElementById("DEBUG");
	drager = document.getElementById("DRAG");

// for Mozilla only
	if (is_nav5up) {
		ITEM_FUNCTIONS = document.getElementById("ITEM_FUNCTIONS");
	}
	//setInterval("window.location.reload()",10000)
	// tree_name, parent_class_name, parent_id are global
	tree_setRoot(parent_class_name, parent_id);
	tree_getRows(tree_name, parent_class_name, parent_id); // temporary, get it "inline"
};

window.onload = init;

///////////////////////////////////////////////////////////////
// helper functions

//adds one item -- catalog to left window 
function add_cat_item(cat_name, cat_class_name, cat_id, cat_parent_class_name, cat_parent_id)
{
	id = "TABD" + cat_parent_id+"_"+cat_parent_class_name;
	var tab=document.getElementById(id);
	
	var new_row = tab.insertRow(tab.rows.length);

	var new_cell = new_row.insertCell(0);
	
        var new_tab = document.createElement("TABLE");
        new_tab.id = "TAB"+cat_id+"_"+cat_class_name;
        //new_tab.priv_d = props;

        var snew_row = new_tab.insertRow(0);
        var snew_cell = snew_row.insertCell(0);
        var img = document.createElement("IMG");
        img.id = "IMG"+cat_id+"_"+cat_class_name;
        img.src = '/co/images/other/plus.gif';
        img.priv_cat_parent_id = cat_parent_id;
	img.priv_cat_parent_class_name = cat_parent_class_name;
        img.priv_cat_id = cat_id;
	img.priv_cat_class_name = cat_class_name;
        img.onclick = function() {tree_showUnfold(this.priv_cat_class_name,this.priv_cat_id);};
        snew_cell.appendChild(img);

        snew_cell = snew_row.insertCell(1);
//	snew_cell.className = "leftList";
        // XXX snew_cell.priv_cat_parent_id = cat_parent_id;
        snew_cell.priv_cat_id = cat_id;
        snew_cell.priv_cat_class_name = cat_class_name;
        snew_cell.onclick = function() {tree_changeActive(this.priv_cat_class_name,this.priv_cat_id,1);};
        var span = document.createElement("SPAN");
        var text = document.createTextNode(cat_name);
        span.appendChild(text);
        snew_cell.appendChild(span);
 
        new_cell.appendChild(new_tab); 
		new_tab.firstChild.firstChild.style.backgroundColor = inactive_color_background;
		new_tab.firstChild.firstChild.style.color = inactive_color_font;

};

